
#ifndef _globals_h
#define _globals_h

#define IMMED_MODE_SPT( info ) \
    ( ((info)->subset_info & 0xFFFF) == PEXCompleteImplementation \
        || (info)->subset_info & PEXImmediateMode )
#define STRUCT_MODE_SPT( info ) \
    ( ((info)->subset_info & 0xFFFF) == PEXCompleteImplementation \
        || (info)->subset_info & PEXStructureMode )
#define WORKS_MODE_SPT( info ) \
    ( ((info)->subset_info & 0xFFFF) == PEXCompleteImplementation \
        || (info)->subset_info & PEXWorkstationOnly )

#define PRIMARY_COLOR "PRIMARY_COLOR"
#define XA_PRIMARY_COLOR XmuInternAtom(XtDisplay(w),_XA_PRIMARY_COLOR)
static AtomPtr _XA_PRIMARY_COLOR = NULL;

#define MEMORY_OFFSET  8
#if 0
#define NUM_MEMORIES  36
#define MAX_COLORS    NUM_MEMORIES+MEMORY_OFFSET
#endif
#define MAX_COLORS    16
#define COLOR(color_el,rgb) ((double)colors[color_el].rgb/256.0)

#define CHANGE_HSV_HUE() \
        pass_value = 1.0; \
        Update_HSV(hueScroll, HUE, (XtPointer)(&pass_value))
#define CHANGE_HSV_SAT() \
        pass_value = 1.0; \
        Update_HSV(satScroll, SAT, (XtPointer)(&pass_value))
#define CHANGE_HSV_VAL() \
        pass_value = 1.0; \
        Update_HSV(valScroll, VAL, (XtPointer)(&pass_value))

#define CHANGE_HLS_HUE() \
        pass_value = 1.0; \
        Update_HLS(hueScroll, HUE, (XtPointer)(&pass_value))
#define CHANGE_HLS_LGT() \
        pass_value = 1.0; \
        Update_HLS(lgtScroll, LGT, (XtPointer)(&pass_value))
#define CHANGE_HLS_SAT() \
        pass_value = 1.0; \
        Update_HLS(satScroll, SAT, (XtPointer)(&pass_value))

#define CHANGE_X() \
        pass_value = 0.00001; \
        Update_CIE(XScroll, XVAL, (XtPointer)(&pass_value))
#define CHANGE_Y() \
        pass_value = 0.00001; \
        Update_CIE(YScroll, YVAL, (XtPointer)(&pass_value))
#define CHANGE_Z() \
        pass_value = 0.00001; \
        Update_CIE(ZScroll, ZVAL, (XtPointer)(&pass_value))


#define CHANGE_RED(element) \
        pass_value = 1.0 - (double)(COLOR(element,red)/255.0); \
        Thumbed(redScroll, RED, (XtPointer)(&pass_value))
#define CHANGE_GREEN(element) \
        pass_value = 1.0 - (double)(COLOR(element,green)/255.0); \
        Thumbed(greenScroll, GREEN, (XtPointer)(&pass_value))
#define CHANGE_BLUE(element) \
        pass_value = 1.0 - (double)(COLOR(element,blue)/255.0); \
        Thumbed(blueScroll, BLUE, (XtPointer)(&pass_value))

#define RED      1
#define GREEN    2
#define BLUE     4
#define LOCKED   8
#define HUE     16
#define SAT     32
#define VAL     64
#define LGT    128
#define XVAL   256
#define YVAL   512
#define ZVAL  1024

#define MIX_COLOR    0
#define RED_COLOR    1
#define GREEN_COLOR  2
#define BLUE_COLOR   3
#define PURE_BLACK   4
#define PURE_RED     5
#define PURE_GREEN   6
#define PURE_BLUE    7

#endif /* _globals_h */
